﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - savage defense bar
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------

local DF = DF_namespace
local _

local vToolTip = CreateFrame("GameTooltip","DroodFocusDefence2ToolTip",nil,"GameTooltipTemplate")
vToolTip:SetOwner(UIParent, "ANCHOR_NONE")

local frame=nil
local frameTexture=nil

local background=nil
local foreground=nil
local text=nil

local cursor=0
local offset = 1

local frequency =1/60
local tempo=(frequency/15)*11

local maxi=0
local current=0
local value=0
	
-- initialisation frames
function DF:init_defensebar_frame()
	
	if not frame then
		
		-- cadre principal
		frame = CreateFrame("FRAME","DF_defensebar_FRAME",DF.anchor[1].frame)
		frame:SetScript("OnMouseDown",function(self,button)
			if button=="LeftButton" then
  			frame:StartMoving()
  		elseif button=="RightButton" then
  			DF:options_show("DFdefensebar",frame)
  		end
		end)
		frame:SetScript("OnMouseUp",function(self,button)
			if button=="LeftButton" then
	  		frame:StopMovingOrSizing()
	  		local anchorx=DF.anchor[1].frame:GetLeft()
	  		local anchory=DF.anchor[1].frame:GetTop()		  			  		
	  		DF_config.defensebar.positionx=DF:alignToGridX(self:GetLeft()-anchorx)
	  		DF_config.defensebar.positiony=DF:alignToGridY(self:GetTop()-anchory)
	  		frame:ClearAllPoints()
	  		frame:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DF_config.defensebar.positionx, DF_config.defensebar.positiony)
				DF.environnement["DFdefensebarleft"]:Hide()
				DF.environnement["DFdefensebartop"]:Hide()
				DF.environnement["DFdefensebarleft"]:Show()
				DF.environnement["DFdefensebartop"]:Show()
		  end
		end)	
		frame:SetScript("OnEnter",function(self,button)
			if DF.configmode then
				DF.DroodFGameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
				DF.DroodFGameTooltip:ClearLines()
				DF.DroodFGameTooltip:AddLine("DROODFOCUS DEFENSEBAR",1,1,0,nil)
				DF.DroodFGameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
				DF.DroodFGameTooltip:AddLine(DF.locale["rightMB"],1,1,1,nil)
				DF.DroodFGameTooltip:Show()		
			end		
		end)		
		frame:SetScript("OnLeave",function(self,button)
			if DF.configmode then DF.DroodFGameTooltip:Hide() end
		end)		

		-- cadre pour la texture
		background = CreateFrame("StatusBar","DF_defensebar_BACKGROUND",frame)
		foreground = CreateFrame("StatusBar","DF_defensebar_FOREGROUND",frame)
		text = foreground:CreateFontString("DF_defensebar_TEXT","ARTWORK")
		frameTexture=frame:CreateTexture("DF_defensebar_FRAME_TEXTURE")
		frame:EnableMouse(false)	
	end
	
	local level = DF_config.defensebar.level*10

	-- paramétres cadre principal
	frame:SetMovable(true)
		
	frame:SetWidth(DF_config.defensebar.width)
	frame:SetHeight(DF_config.defensebar.height)
	frame:ClearAllPoints()
	frame:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DF_config.defensebar.positionx, DF_config.defensebar.positiony)
	frame:SetFrameLevel(level)

	if DF_config.defensebar.border then
		frameTexture:ClearAllPoints()
		frameTexture:SetAllPoints(frame)
		frameTexture:SetTexture(DF_config.defensebar.borderColor.r, DF_config.defensebar.borderColor.v, DF_config.defensebar.borderColor.b,1)
		frame.texture=frameTexture
	else
		frameTexture:ClearAllPoints()
		frameTexture:SetAllPoints(frame)
		frameTexture:SetTexture(DF_config.defensebar.borderColor.r, DF_config.defensebar.borderColor.v, DF_config.defensebar.borderColor.b,0)
		frame.texture=frameTexture
		
	end

	-- paramétres background
	background:SetWidth(DF_config.defensebar.width-DF_config.defensebar.borderSize*2)
	background:SetHeight(DF_config.defensebar.height-DF_config.defensebar.borderSize*2)
	background:SetPoint("TOPLEFT", frame, "TOPLEFT", DF_config.defensebar.borderSize, -DF_config.defensebar.borderSize)
	background:SetStatusBarTexture(DF_config.defensebar.texturePath)
	background:SetStatusBarColor(0.5, 0, 0, 1)
	background:SetOrientation("HORIZONTAL")
	background:SetFrameLevel(level+1)

	-- paramétres foreground
	foreground:SetWidth(DF_config.defensebar.width-DF_config.defensebar.borderSize*2)
	foreground:SetHeight(DF_config.defensebar.height-DF_config.defensebar.borderSize*2)
	foreground:SetPoint("TOPLEFT", frame, "TOPLEFT", DF_config.defensebar.borderSize, -DF_config.defensebar.borderSize)
	foreground:SetStatusBarTexture(DF_config.defensebar.texturePath)
	foreground:SetStatusBarColor(1, 0, 0, 1)
	foreground:SetOrientation("HORIZONTAL")
	foreground:SetMinMaxValues(0, 100)
	foreground:SetFrameLevel(level+2)

	background:SetStatusBarColor(DF_config.defensebar.color.r/3, DF_config.defensebar.color.v/3, DF_config.defensebar.color.b/3, DF_config.defensebar.color.a)
	foreground:SetStatusBarColor(DF_config.defensebar.color.r, DF_config.defensebar.color.v, DF_config.defensebar.color.b, DF_config.defensebar.color.a)
	background:SetOrientation(DF_config.defensebar.orientation)
	foreground:SetOrientation(DF_config.defensebar.orientation)
	
	-- paramétres text
	DF:MySetFont(text,DF_config.defensebar.fontPath,DF_config.defensebar.fontSize)
	text:SetShadowColor(0, 0, 0, 0.75)
	text:SetShadowOffset(0.5, -0.5)
	text:SetTextColor(DF_config.defensebar.textColor.r, DF_config.defensebar.textColor.v, DF_config.defensebar.textColor.b, 1)
	text:SetText("TEST")
	text:ClearAllPoints()
	text:SetPoint(DF_config.defensebar.textAlign, foreground, DF_config.defensebar.textAlign, DF_config.defensebar.textx, DF_config.defensebar.texty)
	
	if not DF_config.defensebar.showText then
		text:Hide()
	else
		text:Show()
	end
	
	if not DF_config.defensebar.enable then 
		frame:Hide()
	else
		frame:Show()
	end

end

local function getTooltipText(...)
	local text = ""
	for i=1,select("#",...) do
		local rgn = select(i,...)
		if rgn and rgn:GetObjectType() == "FontString" then
			text = text .. (rgn:GetText() or "")
		end
	end
	return text == "" and "0" or text
end

local function GetSavageDefense()
	local buffv = UnitAura("player", (GetSpellInfo(62606)))
	local vToolTipText=""
	local sdefense=0
	if buffv then
		vToolTip:ClearLines()
		vToolTip:SetUnitBuff("player",buffv)
		vToolTipText = getTooltipText(vToolTip:GetRegions())
		if vToolTipText then
			sdefense = tonumber(string.match(vToolTipText,"%d+"))
		end
	end
	return sdefense

end

-- gestion de l'animation
function DF:defensebar_update(elapsed)
	
	if not DF_config.defensebar.enable or not DF:toggle_isEnable() then return end

	local currentForm = DF:currentForm()
	if not DF:form_goofForm(DF_config.defensebar.form,currentForm) then
		frame:Hide()
		return
	end

	tempo=tempo+elapsed
	if tempo<frequency then return end
	tempo=0	

	if DF.configmode then
		
		current=50
		maxi=100
	
	else

		local base, posBuff, negBuff = UnitAttackPower("player")
		local puissance = base + posBuff + negBuff
		local mastery = ((GetMastery()*4)/100)+1
		local coef = 0.35*mastery

		maxi = puissance*coef
		current = GetSavageDefense()
		
	end

	if current>0 then
		frame:Show()
	else
		frame:Hide()
	end

	maxi2=maxi
	if maxi2==0 then
		maxi2=100
	end

	value = 100 * (current/maxi2)
	
	if cursor>value then
		
		cursor = cursor - DF_config.cursorspeed
		if cursor<value then cursor=value end
		
	elseif cursor<value then
		
		cursor = cursor + DF_config.cursorspeed
		if cursor>value then cursor=value end
		
	end
	
	foreground:SetValue(cursor)
	text:SetText(DF:formatText(maxi,current,DF_config.defensebar.sformat,0))	
	
end

-- enable/disable déplacement du cadre avec la souris
function DF:defensebar_toogle_lock(flag)
	
	frame:EnableMouse(flag)
	
end

function DF:defensebar_reinit()
	
	DF:init_defensebar_frame()
	
end
